; Hugi Compo #25 -  The world has gone Sudoku
;
; Entry by Flyke ( ville@heaven.dk )
; 
; Last changed 30.01.2006
;
; An attempt at optimizing the example suite..
; 
; masm 6.14
; ml /c entry.asm
; link /tiny entry.obj,entry.com, , , ,

.model tiny
.486
.code

	org 100h
	
start:
	mov		di, puzzle
	mov		si, di		; store puzzle start address in si
	mov		cl, 171		; ch = 00 from general.txt
nextcharacter:
	mov		ah, 08h
	int		21h
	stosb
	loopw	nextcharacter
	mov		al, '$'
	stosb


	mov		bx, si
	mov		dh, '.'
	; we can spare the first call to solve and just let the program run into the solve function
	;call	solve
	; we will never retun from solve function ... ( it's in the rules baby :D )
	
;-------------------------------------------------------------------------------
;Solve the puzzle using backtracking (recursive tree search)
solve:	
	pusha
	;push	bx		;save index (I) into puzzle array (0..81)
	;push	dx		;save Digit

	cmp		bx, 169+puzzle
	jb		solve10		; (jump if not)
	;Output the solution
	mov		dx, si
	mov		ah, 9
	int		21h
	; exit !
	int		20h
solve10:
	;cmp	byte ptr [bx], '.'	;is cell empty?; if Puzzle(I) = 0 then...
	cmp	byte ptr [bx], dh
	jne	solve30		;(jump if not)

	mov	dl, '1'		;try all 9 digits...; for Digit:= 1, 9 do...
solve20:
	call	okay		;if Okay then...
	jc		solve25		;(jump if not)
	mov		byte ptr [bx], dl	;make trial entry with digit; Puzzle(I):= Digit
incloop1:
	inc		bx
	;cmp		byte ptr [bx], '.'
	cmp		byte ptr [bx], dh
	jl		incloop1
	call	solve
decloop1:
	dec		bx
	cmp		byte ptr [bx], '0'
	jb		decloop1	
	mov		byte ptr [bx], dh
solve25:
	inc		dx				; next digit
	cmp		dl, '9'		;loop for digits 1..9
	jle		solve20
	jmp		solve40
solve30:
incloop2:
	inc		bx
	cmp		byte ptr [bx], dh
	jl		incloop2
	call	solve		;else	Solve(I+1)
solve40:
	;pop		dx		;restore Digit
	;pop		bx		;restore index (I)
	popa
	ret

;-------------------------------------------------------------------------------
;Returns carry flag set if the digit in dl is already used

;Check if a row already contains the digit:

okay:

; check row
	mov	di, bx
okay_1:
	inc	di
	cmp	byte ptr [di], 0Dh
	jne	okay_1
	dec	di
	mov	cl, 9
okay_2:
	cmp	byte ptr [di], dl
	je	badmove
	dec	di
	dec di
	loopw	okay_2
	
; check column
	mov	ax, bx		;get index (I) into puzzle array
	sub	ax, si
	mov	cl, 19
	div	cl		;al:= ax/cl -> ah = column (remainder), al = row
	mov	al, ah
	;mov	ah, 0
	cbw
	
	mov	di, si
	add	di, ax
	
	mov	cl, 9
okay_4:
	cmp	byte ptr [di], dl
	je	badmove
	add	di, 19
	loopw	okay_4
	
; check quadrant
	
	mov		cl, 6
	div		cl
	mul		cl
	
	cmp		bx, puzzle + 57
	jb		done
	add		ax, 57
	cmp		bx, puzzle + 114
	jb		done
	add		ax, 57	
done:
	mov		di, si
	add		di, ax

	mov	cl, 3
quadloop:
	cmp	byte ptr [di], dl
	je	badmove
	cmp	byte ptr [di+2], dl
	je	badmove
	cmp	byte ptr [di+4], dl
	je	badmove
	add	di, 19	
	loopw	quadloop

	clc
	ret


badmove:
	stc
	ret

;puzzle	db	171 dup (0)	;9x9 array of cells
puzzle:
	end	start